//uvXeIOr[[

#include "esplib0.h"
#include <time.h>

#define SAVE_WINDOW_NUM 7	//̏ꂵ̂
void save_file(
unsigned int *source_L,
unsigned int *source_R,
int wX,int wY,//̉摜TCY
int dx,//炵xl Lpos-Rpos
int dy//炵yl
)
{
int mX,mY;//`TCY
int dt_XL,dt_XR;
int dt_YL,dt_YR;
char fname[256];
time_t timer;
struct tm *date;

mX=wX-abs(dx);
mY=wY-abs(dy);
ESP_CreateImage( SAVE_WINDOW_NUM,  "savefile",  -1, -1, mX*2, mY, 10);


dt_XL=0;dt_XR=0;
if (dx>0) dt_XL=dx; else dt_XR=abs(dx);
dt_YL=0;dt_YR=0;
if (dy>0) dt_YL=dy; else dt_YR=abs(dy);

for(int y=0;y<mY;y++){
  for(int x=0;x<mX;x++){
    *(ESP_VramPtr[SAVE_WINDOW_NUM]+mX*2*y+x)=*(source_L+x+dt_XL+wX*(y+dt_YL));
    *(ESP_VramPtr[SAVE_WINDOW_NUM]+mX*2*y+x+mX)=*(source_R+x+dt_XR+wX*(y+dt_YR));
  }
}
ESP_Select(SAVE_WINDOW_NUM);ESP_Update_(SAVE_WINDOW_NUM);
timer = time(NULL);
date = localtime(&timer);
strftime(fname, 255, "Sad-%y%m%d_%H_%M_%S", date);
ESP_ImageSave(ESP_JPEG, fname, 0, 0, mX*2, mY);
//ESP_Pause("saved");
ESP_DestroyImage(SAVE_WINDOW_NUM);

}



void mk_buruburu(
unsigned int *source_L,
unsigned int *source_R,
int wX,int wY,//̉摜TCY
int dx,//炵xl Lpos-Rpos
int dy
)
{
int mX,mY;//`TCY
int dt_XL,dt_XR;
int dt_YL,dt_YR;

mX=wX-abs(dx);
mY=wY-abs(dy);

for(int y=0;y<wY;y++){
  for(int x=0;x<wX;x++){
    *(ESP_VramPtr[4]+wX*y+x)=0;
    *(ESP_VramPtr[5]+wX*y+x)=0;
  }
}

dt_XL=0;dt_XR=0;
if (dx>0) dt_XL=dx; else dt_XR=abs(dx);
dt_YL=0;dt_YR=0;
if (dy>0) dt_YL=dy; else dt_YR=abs(dy);

for(int y=0;y<mY;y++){
  for(int x=0;x<mX;x++){
    *(ESP_VramPtr[4]+wX*y+x)=*(source_L+x+dt_XL+wX*(y+dt_YL));
    *(ESP_VramPtr[5]+wX*y+x)=*(source_R+x+dt_XR+wX*(y+dt_YR));
  }
}
}

#define kongou(c0,c1) RGB2C((C2R(c0)|C2R(c1)), (C2G(c0)|C2G(c1)), (C2B(c0)|C2B(c1)))
void mk_anaglyph(
unsigned int *source_L,
unsigned int *source_R,
unsigned int *dest,
int wX,int wY,//̉摜TCY
int dx,//炵l Lpos-Rpos
int dy
)

{
int colL,rL,gL,bL;
int colR,rR,gR,bR;
int mX,mY;//`TCY
int dt_XL,dt_XR;
int dt_YL,dt_YR;

mX=wX-abs(dx);
mY=wY-abs(dy);

for(int y=0;y<wY;y++){
  for(int x=0;x<wX;x++){
    *(dest+wX*y+x)=0;
  }
}

dt_XL=0;dt_XR=0;
if (dx>0) dt_XL=dx; else dt_XR=abs(dx);
dt_YL=0;dt_YR=0;
if (dy>0) dt_YL=dy; else dt_YR=abs(dy);

for(int y=0;y<mY;y++){
  for(int x=0;x<mX;x++){

	colL = *(source_L+x+dt_XL+wX*(y+dt_YL));
	C2RGB(colL,&rL,&gL,&bL);

	colR = *(source_R+x+dt_XR+wX*(y+dt_YR));
	C2RGB(colR,&rR,&gR,&bR);
	rR = (int)(0.299*rR+0.587*gR+0.114*bR);
    *(dest+wX*y+x)=kongou(RGB2C(0,gL,bL),RGB2C(rR,0,0));
  }
}
}

void ESP_Ready(void)
{
	ESP_MOUSE = 1;

}
void ESP_Main(void)

{
		int lx,ly;
//		lx=esp_iw[0].wx/2; ly=esp_iw[0].wy;
		lx=esp_iw[0].wx; ly=esp_iw[0].wy;	//̏ꂵ̂
		int pos_XL,pos_XR;
		int tmp_XL,tmp_XR;
		int area_L,area_R;
		int flg_L=0,flg_R=0;
		int XL_0,XR_0;
		int buruburu=0,buruflg=0;
		unsigned int *buruburu_pt;
		int dy=0;
		int resX,resY,zoom;

		if (ESP_GetDisplayMode(0)) {

		resX = GetSystemMetrics(SM_CXSCREEN);
		resY = GetSystemMetrics(SM_CYSCREEN);
		//\̔䗦Fʂ̔TCYɕ\
//		zoom=((resX*100)/esp_iw[0].wx)/2;
		zoom=((resX*100)/lx)/4;
//		zoom=((lx*100)/resX);
		
		//
		ESP_CreateImage( 1,  "Left side",  0, 0, lx, ly, 30);
		ESP_CreateImage( 2,  "Right side",  0, 0, lx, ly, 30);
		ESP_CreateImage( 4,  "buruburuL",  0, 0, lx, ly, 10);
		ESP_CreateImage( 3,  "Preview",  0, (ly*zoom)/100, lx, ly, zoom*2);
		ESP_CreateImage( 5,  "buruburuR",  0, 0, lx, ly, 10);
		ESP_CreateImage( 6,  "SidebySide",  0, 0, lx*2, ly, zoom);
#define SBS_WINDOW_NUM 6	//̏ꂵ̂

		for(int y=0;y<ly;y++){
		  for(int x=0;x<lx;x++){
//			*(ESP_VramPtr[SAVE_WINDOW_NUM]+lx*2*y+x)=*(ESP_VramPtr[0]+x+lx*y);
//		    *(ESP_VramPtr[SAVE_WINDOW_NUM]+lx*2*y+x+lx)=*(ESP_VramPtr[0]+x+lx*y);
			ESP_VramPtr[SBS_WINDOW_NUM][lx*2*y+x]=ESP_VramPtr[0][x+lx*y];
		    ESP_VramPtr[SBS_WINDOW_NUM][lx*2*y+x+lx]=ESP_VramPtr[0][x+lx*y];
		  }
		}

		//Ẻ摜𕪗
		for (int y=0;y<ly;y++){
			for (int x=0;x<lx*2;x++) {
					if (x<lx) ESP_VramPtr[1][x+lx*y] = ESP_VramPtr[SBS_WINDOW_NUM][x+lx*y*2];
						else  ESP_VramPtr[2][x-lx+lx*y] = ESP_VramPtr[SBS_WINDOW_NUM][x+lx*y*2];
			}
		}

		buruburu=1;
		
		if (buruburu) 
			mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,0,0);
		else
			mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,0,0);
		ESP_SetDisplayMode(3,HALFTONE);
		ESP_Select(3);ESP_Update_(3);

//		ESP_OpenTextWindow(0,-1,-1,-1,-1);

		ESP_OpenButtonBox((esp_iw[SBS_WINDOW_NUM].wx*zoom)/100, 0, 4, 2);
		ESP_SetButtonBoxTitle(0, "Anaglyph");
		ESP_SetButtonBoxTitle(1, "");
		ESP_SetButtonBoxTitle(2, "Buruburu");
		ESP_SetButtonBoxTitle(3, "Save");
		ESP_SetButtonBoxTitle(4, "");
		ESP_SetButtonBoxTitle(5, "");
		ESP_SetButtonBoxTitle(6, "");
		ESP_SetButtonBoxTitle(7, "Quit");


		ESP_Select(0);

		ESP_ZoomImage(0, 10);
		ESP_PlaceImage(0, 0, 0);
		ESP_Select(SBS_WINDOW_NUM);
		ESP_PlaceImage(SBS_WINDOW_NUM, 0, 0);
		ESP_SetDisplayMode(SBS_WINDOW_NUM,HALFTONE);
		ESP_LineXOR(lx/2, 0, lx/2, ly);
		ESP_LineXOR(lx/2+lx, 0, lx/2+lx, ly);
		pos_XL=lx/2;tmp_XL=pos_XL;
		pos_XR=lx/2+lx;tmp_XR=pos_XR;
		XL_0=pos_XL;XR_0=pos_XR;
		ESP_Update_(SBS_WINDOW_NUM);

		while(1){
				area_L = (((tmp_XL-100)<ESP_MX)&&(ESP_MX<(tmp_XL+100))&&(ESP_MX<lx)&&
					       (ESP_MY<(ly-50))&&(50<ESP_MY)&&(ESP_MW==SBS_WINDOW_NUM));
				area_R = (((tmp_XR-100)<ESP_MX)&&(ESP_MX<(tmp_XR+100))&&(lx<=ESP_MX)&&
					       (ESP_MY<(ly-50))&&(50<ESP_MY)&&(ESP_MW==SBS_WINDOW_NUM));
				if (area_L){
					ESP_Select(SBS_WINDOW_NUM);
					flg_L=1;
					if (ESP_ML) pos_XL=ESP_MX;

					ESP_LineXOR(tmp_XL, 0, tmp_XL, ly);ESP_LineXOR(ESP_MX, 0, ESP_MX, ly);
					tmp_XL=ESP_MX;ESP_Update_(SBS_WINDOW_NUM);

					if (buruburu) 
						mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,ESP_MX-(pos_XR-lx),dy);
					else
						mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,ESP_MX-(pos_XR-lx),dy);
					ESP_Update_(3);

				} else {
					if (flg_L) {
						ESP_Select(SBS_WINDOW_NUM);
						flg_L=0;
						ESP_LineXOR(tmp_XL, 0, tmp_XL, ly);ESP_LineXOR(pos_XL, 0, pos_XL, ly);
						tmp_XL=pos_XL;ESP_Update_(SBS_WINDOW_NUM);

						if (buruburu) 
							mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,pos_XL-(pos_XR-lx),dy);
						else
							mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,pos_XL-(pos_XR-lx),dy);
						ESP_Update_(3);
					}
				}
				if (area_R){
					ESP_Select(SBS_WINDOW_NUM);
					flg_R=1;
					if (ESP_ML) pos_XR=ESP_MX;

					ESP_LineXOR(tmp_XR, 0, tmp_XR, ly);ESP_LineXOR(ESP_MX, 0, ESP_MX, ly);
					tmp_XR=ESP_MX;ESP_Update_(SBS_WINDOW_NUM);

					if (buruburu) 
						mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,pos_XL-(ESP_MX-lx),dy);
					else
						mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,pos_XL-(ESP_MX-lx),dy);
					ESP_Update_(3);
				} else {
					if (flg_R) {
						ESP_Select(SBS_WINDOW_NUM);
						flg_R=0;
						ESP_LineXOR(tmp_XR, 0, tmp_XR, ly);ESP_LineXOR(pos_XR, 0, pos_XR, ly);
						tmp_XR=pos_XR;ESP_Update_(SBS_WINDOW_NUM);

						if (buruburu) 
							mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,pos_XL-(pos_XR-lx),dy);
						else
							mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,pos_XL-(pos_XR-lx),dy);
						ESP_Update_(3);

					}
				}
				if (buruburu){
					if (buruflg) 
						{buruburu_pt=ESP_VramPtr[4];buruflg=0;}
					else
						{buruburu_pt=ESP_VramPtr[5];buruflg=1;}
					for(int i=0;i<lx*ly;i++) *(ESP_VramPtr[3]+i)=*(buruburu_pt+i);


					ESP_Select(3);ESP_Update_(3);

				}
				if (ESP_GetButtonBox(0)) {
					buruburu=0;
					mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,pos_XL-(pos_XR-lx),dy);
					ESP_Select(3);ESP_Update_(3);
				}
				if (ESP_GetButtonBox(2)) {
					buruburu=1;
					mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,pos_XL-(pos_XR-lx),dy);
					ESP_Select(3);ESP_Update_(3);
				}

				if (ESP_GetButtonBox(1)) {//UP
					if (dy<ly) {
						dy++;
						if (buruburu) 
							mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,pos_XL-(pos_XR-lx),dy);
						else
							mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,pos_XL-(pos_XR-lx),dy);
						ESP_Update_(3);
					}
				}
				if (ESP_GetButtonBox(5)) {//DOWN
					if (-(ly)<dy) {
						dy--;
						if (buruburu) 
							mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,pos_XL-(pos_XR-lx),dy);
						else
							mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,pos_XL-(pos_XR-lx),dy);
						ESP_Update_(3);
					}
				}
				if (ESP_GetButtonBox(4)) {//LEFT
					pos_XL--;ESP_Select(SBS_WINDOW_NUM);
					ESP_LineXOR(tmp_XL, 0, tmp_XL, ly);ESP_LineXOR(pos_XL, 0, pos_XL, ly);
					tmp_XL=pos_XL;ESP_Update_(SBS_WINDOW_NUM);

					ESP_Select(3);
					if (buruburu) 
						mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,pos_XL-(pos_XR-lx),dy);
					else
						mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,pos_XL-(pos_XR-lx),dy);
					ESP_Update_(3);
				}
				if (ESP_GetButtonBox(6)) {//RIGHT
					pos_XL++;ESP_Select(SBS_WINDOW_NUM);
					ESP_LineXOR(tmp_XL, 0, tmp_XL, ly);ESP_LineXOR(pos_XL, 0, pos_XL, ly);
					tmp_XL=pos_XL;ESP_Update_(SBS_WINDOW_NUM);

					ESP_Select(3);
					if (buruburu) 
						mk_buruburu(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,pos_XL-(pos_XR-lx),dy);
					else
						mk_anaglyph(ESP_VramPtr[1],ESP_VramPtr[2],ESP_VramPtr[3],lx,ly,pos_XL-(pos_XR-lx),dy);
					ESP_Update_(3);
				}

				if (ESP_GetButtonBox(3)) save_file(ESP_VramPtr[1],ESP_VramPtr[2],lx,ly,pos_XL-(pos_XR-lx),dy);

				if (ESP_GetButtonBox(7)) goto end;

//			ESP_Printf("%d:%d:%d\r",ESP_MX,ESP_MY,ESP_MW);
			ESP_Sleep(100);

		}		
	} else {
		ESP_Pause("uvXeIO摜hbOĉ");
	}
end:
//	ESP_CloseTextWindow(0);
	ESP_CloseButtonBox();
	ESP_DestroyImage(0);
	ESP_DestroyImage(1);
	ESP_DestroyImage(2);
	ESP_DestroyImage(3);
	ESP_DestroyImage(4);
	ESP_DestroyImage(5);
	ESP_DestroyImage(SBS_WINDOW_NUM);

}
void ESP_Finish(void)
{
}
